#!/usr/bin/python

__author__ = "Mohammed Sameer <msameer@foolab.org>"
__version__ = "$Id$"

import _mysql

def items(conf):
    """
    \brief mysql driver implementation

    This is the MySQL module. It handles conecting to the database and getting
    all the feeds to be parsed.

    \param conf a dictionary. The keys used are host, user, pass, db and prefix.
    \return a list of dictionaries. Each one has the url, id, etag and modified keys.

    """
    # Todo: How to disconnect ?
    conn = _mysql.connect(host=conf["host"], user=conf["user"], passwd=conf["pass"],
                          db=conf["db"], connect_timeout=5)
    query = "SELECT nid as id, url, etag, modified from %sfooaggregator_feed" % conf["prefix"]
    conn.query(query)
    res = conn.use_result()
    return res.fetch_row(maxrows=0, how=1)
