#!/usr/bin/python

# todo:
# user agent ;-)
# we are getting document empty although the file doesn't exist.
# Cleaning. This is my 1st real python program.
__author__ = "Mohammed Sameer <msameer@foolab.org>"
__version__ = "$Id$"

try:
    import sys
    import feedparser
    import tempfile
    import os
    import time
    import xmlrpclib
#    import pprint
except Exception, e:
    print "ER: I wasn't able to load all the modules I need: %s" % str(e)
    sys.exit(1)


class Parser:
    def __init__(self, args):
        # todo: bad
        url = args['url']
        etag = None
        modified = None
        if args.has_key('etag'):
            etag = args['etag']
        if args.has_key('modified'):
            modified = time.gmtime(int(args['modified']))

        self.feed = feedparser.parse(url, etag, modified)

        self.file = ""
        self.node = {}
        self.node['items'] = []

        # is this correct ?
        if not os.path.isfile(url):
            int(self.feed.status) >= 400:
                raise Exception, str(self.feed["bozo_exception"])
#        if len(self.feed.feed) == 0:
#            raise Exception, str(self.feed["bozo_exception"])

        #if self.feed.has_key("bozo_exception"):
        #    raise Exception, str(self.feed["bozo_exception"])

        self.url = url

    def save(self):
        """Save the feed and feed items."""
        self.file = tempfile.mktemp()
        self.save_http()
        self.save_feed()
        self.save_feed_items()
#        pprint.pprint(self.node)
        res = xmlrpclib.dumps(tuple([self.node]), 'FooParser',allow_none=1)
        open(self.file, 'w').write(res)
        

    def get_file(self):
        """Get the file where the data was saved"""
        return self.file


    def save_http(self):
        """Save the HTTP information to our feed dictionary"""
        # todo: http errors.
        try:
            self.node['etag'] = self.feed.etag
        except:
            pass

        try:
            self.node['modified'] = time.strftime('%s', self.feed.modified)
        except:
            pass

        if not os.path.isfile(self.url):
            self.node['http_code'] = self.feed.status


    def save_feed_item(self, item):
        """Save a feed item to a file"""
        _item = {}
        title = ""
        guid = ""
        link = ""
        content = ""
        tags = []
        tm = 0

        link = item.link

        try:
            title = item.title
        except:
            title = 'Untitled feed item.'
            pass

        try:
            guid = item.id
        except:
            guid = link
            pass

        try:
            content = item.summary
        except:
            content = item.content[0].value
            pass

        try:
            tm = item.published_parsed
        except:
            try:
                tm = item.updated_parsed
            except:
                try:
                    tm = item.created_parsed
                except:
                    tm = time.localtime()

        tm = time.strftime('%s', tm)

        try:
            _item['geo_long'] = item.geo_lon
        except:
            pass
        try:
            _item['geo_lat'] = item.geo_lat
        except:
            pass
        try:
            _item['geo_point'] = item.geo_point
        except:
            pass

        _item['title'] = title
        _item['link'] = link
        _item['body'] = content
        _item['guid'] = guid
        _item['time'] = tm

        try:
            _item['author'] = item.author
#            _item['author'] = item.author_detail.name
        except:
            pass

        try:
            # Fuck facebook.
            tags.extend([tag.term for tag in item.tags if tag.term != None])
            _item['tags'] = tags
        except:
            pass

        self.node['items'].append(_item)


    def save_feed_items(self):
        """Save the feed items to files"""
        for entry in self.feed.entries:
            self.save_feed_item(entry)


    def save_feed(self):
        """Saves the feed and feed image information to a feed file and image file"""
        try:
            self.node['feed_title'] = self.feed.feed.title
        except:
            self.node['feed_title'] = ''
            pass

        try:
            self.node['body'] = self.feed.feed.description
        except:
            pass

        try:
            self.node['link'] = self.feed.feed.link
        except:
            pass

        try:
            self.node['image_url'] = self.feed.feed.image.href
            self.node['image_link'] = self.feed.feed.image.link
            self.node['image_title'] = self.feed.feed.image.title
        except:
            pass

        if not os.path.isfile(self.url):
            self.node['url'] = self.feed.href


if __name__ == "__main__":
    args = {}
    if len(sys.argv) != 3 and len(sys.argv) != 5 and len(sys.argv) != 7:
        print "ER: usage: <-url URL> [-etag ETAG] [-modified MODIFIED]"
        sys.exit(1)
    else:
        x = 1
        while x < len(sys.argv):
            if sys.argv[x] == "-url":
                args['url'] = sys.argv[x+1]
            elif sys.argv[x] == "-etag":
                args['etag'] = sys.argv[x+1]
            elif sys.argv[x] == "-modified":
                args['modified'] = sys.argv[x+1]
            x = x+2
        try:
            res = Parser(args)
            res.save()
            print "OK: %s" % res.get_file()
            sys.exit(0)
        except Exception, e:
            print "ER: %s" % e,
            sys.exit(2)
